
set echo on
set serveroutput on

CREATE OR REPLACE TRIGGER t1_insert_trigger
AFTER INSERT ON t1
BEGIN
   DBMS_OUTPUT.PUT_LINE('T1 trigger fired...');
END insert_trigger;
/

CREATE OR REPLACE TRIGGER t2_insert_trigger
AFTER INSERT ON t2
BEGIN
   DBMS_OUTPUT.PUT_LINE('T2 trigger fired...');
END insert_trigger;
/

INSERT ALL
   --<>--
   WHEN owner = 'SYSTEM'
   THEN
      INTO t1 (owner, object_name)
      VALUES  (owner, object_name)
   --<>--
   WHEN object_type = 'TABLE'
   THEN
      INTO t2 (owner, object_name, object_type)
      VALUES  (owner, object_name, object_type)
   --<>--
SELECT owner
,      object_type
,      object_name
FROM   all_objects;

ROLLBACK;
