
set echo on

DROP TABLE source_table;

ALTER TABLE t2 DROP CONSTRAINT fk2;
ALTER TABLE t3 DROP CONSTRAINT fk3;
ALTER TABLE t4 DROP CONSTRAINT fk4;

ALTER TABLE t1 DROP PRIMARY KEY;
ALTER TABLE t2 DROP PRIMARY KEY;
ALTER TABLE t3 DROP PRIMARY KEY;

ALTER TABLE t1 ADD PRIMARY KEY (object_id);
ALTER TABLE t2 ADD PRIMARY KEY (object_id);
ALTER TABLE t3 ADD PRIMARY KEY (object_id);

ALTER TABLE t2 ADD
   CONSTRAINT fk2
   FOREIGN KEY (object_id)
   REFERENCES t1 (object_id);

ALTER TABLE t3 ADD
   CONSTRAINT fk3
   FOREIGN KEY (object_id)
   REFERENCES t1 (object_id);

ALTER TABLE t4 ADD
   CONSTRAINT fk4
   FOREIGN KEY (object_id)
   REFERENCES t1 (object_id);

CREATE TABLE source_table
PARALLEL 2
AS
   SELECT *
   FROM   all_objects;

BEGIN
   DBMS_STATS.GATHER_TABLE_STATS(user,'source_table');
END;
/

ALTER TABLE t1 PARALLEL;
ALTER TABLE t2 PARALLEL;
ALTER TABLE t3 PARALLEL;
ALTER TABLE t4 PARALLEL;

ALTER SESSION ENABLE PARALLEL QUERY;
ALTER SESSION ENABLE PARALLEL DML;

INSERT /*+ PARALLEL(t1) */ ALL
   --<>--
   INTO t1 (owner, object_id)
   VALUES  (owner, object_id)
   --<>--
   INTO t2 (owner, object_id)
   VALUES  (owner, object_id)
   --<>--
   INTO t3 (owner, object_id)
   VALUES  (owner, object_id)
   --<>--
   INTO t4 (owner, object_id)
   VALUES  (owner, object_id)
   --<>--
SELECT /*+ PARALLEL(source_table) */
       owner
,      object_type
,      object_name
,      object_id
,      created
FROM   source_table;

SELECT * FROM v$pq_sesstat;

ROLLBACK;

